ents = {}
ents.objects = {}
ents.objpath = "states/game/entities/"
local register = {}
local id = 0

function ents.Startup()
	register["player"] = love.filesystem.load(ents.objpath .. "player.lua")	
	register["editor_player"] = love.filesystem.load(ents.objpath .. "editor_player.lua")	
	register["enemy"] = love.filesystem.load(ents.objpath .. "enemy.lua")	
	register["fireball"] = love.filesystem.load(ents.objpath .. "fireball.lua")	
	register["fireball_exp"] = love.filesystem.load(ents.objpath .. "fireball_exp.lua")	
	register["icenova"] = love.filesystem.load(ents.objpath .. "icenova.lua")	
end

function ents.Derive(name)
	return love.filesystem.load(ents.objpath .. name .. ".lua")()
end

function ents.Create(name, x, y, bg, arg1, arg2, arg3, arg4, arg5)
	if not x then
		x = 0
	end
	
	if not y then
		y = 0
	end
	
	if not bg then
		bg = false
	end
	
	if not arg1 then
		arg1 = 0
	end
	
	if not arg1 then
		arg2 = 0
	end
	
	if not arg3 then
		arg3 = 0
	end
	
	if not arg4 then
		arg4 = 0
	end
	
	if not arg5 then
		arg5 = 0
	end

	if register [name] then
		id = id + 1
		local ent = register[name]()
		ent:load(id)
		ent.type = name
		ent:setPos(x, y, arg1, arg2, arg3, arg4, arg5)
		ent.id = id
		ent.bg = bg
		ents.objects[id] = ent
		return ents.objects[id]
	else
		print("Error: Entity " .. name .. " does not exist! ")
		return false;
	end
end

function ents:update(dt)
	for i, ent in pairs(ents.objects) do
		if ent.update then
			ent:update(dt)
		end
	end
end

function ents:drawBG()

	for i, ent in pairs(ents.objects) do
		if ent.bg then
			if ent.draw then
				ent:draw(dt)
			end
		end
	end
end

function ents:draw()
	for i, ent in pairs(ents.objects) do
		if not ent.bg then
			if ent.draw then
				ent:draw(dt)
			end
		end
	end
end

function ents.destroy(id)
	if ents.objects[id] then		
		if ents.objects[id].body then
			ents.objects[id].body:destroy()
		end
	
		ents.objects[id] = nil
	end
end