local ent = ents.Derive("base")

function ent:load(x, y)
	fireball_count = fireball_count + 1
	self.birth = love.timer.getTime()

	self.ang = 0

	self.image = textures.fireball
	self.w = self.image:getWidth()
	self.h = self.image:getHeight()
	
	self.body = love.physics.newBody(world, 0, 0, "dynamic")
	self.shape = love.physics.newCircleShape(self.w/2)
	self.fixture = love.physics.newFixture(self.body, self.shape, 1) 
	self.fixture:setUserData("fireball"..fireball_count)
	self.fixture:setSensor(true)
	
end

function ent:initial_push()

	local fireball_force = 350000
	local difference_x = self.world_mouse_x - self.x
	local difference_y = self.world_mouse_y - self.y
	local fireball_x_ratio, fireball_y_ratio
	
	self.moving = true
	
	if difference_x >= 0 then --calculate initial initial force to the fireballds
		if difference_y >= 0 then 
			fireball_x_ratio =  difference_x / (difference_x + difference_y)
			fireball_y_ratio =  difference_y / (difference_x + difference_y)
		elseif difference_y < 0 then
			fireball_x_ratio =  difference_x / (difference_x + (-difference_y))
			fireball_y_ratio =  -1*((-difference_y) / (difference_x + (-difference_y)))
		end
		
	elseif difference_x < 0 then
		if difference_y >= 0 then
			fireball_x_ratio =  -1*((-difference_x) / ((-difference_x) + difference_y))
			fireball_y_ratio =  difference_y / ((-difference_x) + difference_y)
		elseif difference_y < 0 then
			fireball_x_ratio =  -1*((-difference_x) / ((-difference_x) + (-difference_y)))
			fireball_y_ratio =  -1*((-difference_y) / ((-difference_x) + (-difference_y)))
		end
	end
	
	self.body:applyForce(	fireball_x_ratio * fireball_force, 
							fireball_y_ratio * fireball_force)
	
end

function ent:setPos( x, y, fire_dam, fire_exp, world_mouse_x, world_mouse_y, cast_time )
	self.x = x
	self.y = y
	self.body:setPosition( x, y )
	
	self.dam = fire_dam
	self.exp = fire_exp
	self.cast_time = cast_time
	
	self.world_mouse_x = world_mouse_x
	self.world_mouse_y = world_mouse_y

end

function ent:getPos()
	return self.x, self.y, self.a;
end

function ent:update(dt)
	self.x, self.y = self.body:getPosition()	
	self.a = self.body:getAngle()
	if not self.moving then
		self:initial_push()
	end
	
	self:update_collision()
end

function ent:update_collision()

	if self.colliding then
		if self.colliding ~= "player" then
			if self.exp == true then
				ents.Create("fireball_exp", self.x, self.y, true, self.dam, self.cast_time)
			end			

			fireball_count = fireball_count - 1 
			ents.destroy(self.id)
			
		end
		return
	end
end


function ent:draw()
	love.graphics.draw( self.image, self.x, self.y, self.a, 1, 1, self.w/2, self.h/2)
end

return ent;