local ent = ents.Derive("base")

function ent:load(id)
	fireball_exp_count = fireball_exp_count + 1

	self.image = textures.fireball_exp
	self.w = self.image:getWidth()
	self.h = self.image:getHeight()
	self.birth = love.timer.getTime()
	
	self.body = love.physics.newBody(world, 0, 0, "dynamic")
	self.shape = love.physics.newCircleShape(self.w/2)
	self.fixture = love.physics.newFixture(self.body, self.shape, 1) 
	self.fixture:setUserData("fireball_exp"..fireball_exp_count)
	self.fixture:setSensor(true)
end

function ent:setPos( x, y, dam, cast_time)
	self.x = x
	self.y = y
	self.body:setPosition( x, y )
	
	self.cast_time = cast_time
	self.dam = dam/4
	self.fire_exp = fire_exp
end

function ent:getPos()
	return self.x, self.y, self.a;
end

function ent:update(dt)
	if self.birth ~= love.timer.getTime() then
		fireball_exp_count = fireball_exp_count - 	1
		ents.destroy(self.id)
	end
end

function ent:update_collision()
end


function ent:draw()
	love.graphics.draw( self.image, self.x, self.y, self.a, 1, 1, self.w/2, self.h/2)
end

return ent;