local ent = ents.Derive("base")

function ent:load(x, y)
	icenova_count = icenova_count + 1
	self.birth = love.timer.getTime()

	self.ang = 0

	self.image = textures.icenova_explosion
	self.w = self.image:getWidth()
	self.h = self.image:getHeight()
end

function ent:setPos( x, y, max_scale )
	self.x = x
	self.y = y
	
	self.dam = fire_dam
	self.exp = fire_exp
	
	self.world_mouse_x = world_mouse_x
	self.world_mouse_y = world_mouse_y
	self.startup_done = true
end

function ent:getPos()
	return self.x, self.y, self.a;
end

function ent:update(dt)
	if self.startup_done then
		self.startup_done = false
		self:create_nova()
	end
	
	self.x, self.y = self.body:getPosition()	
	
	if self.birth ~= love.timer.getTime() then
		icenova_count = icenova_count - 1 
		ents.destroy(self.id)
	end
end

function ent:create_nova()
	self.body = love.physics.newBody(world, 0, 0, "dynamic")
	self.shape = love.physics.newCircleShape(self.w/2)
	self.fixture = love.physics.newFixture(self.body, self.shape, 1) 
	self.fixture:setUserData("icenova"..icenova_count)
	self.fixture:setSensor(true)
	
	self.body:setPosition( self.x, self.y )
end

function ent:draw()
	love.graphics.draw( self.image, self.x, self.y, self.a, 1, 1, self.w/2, self.h/2)
end

return ent;